/*

$Id: item_id.h,v 1.7 2008/04/11 10:54:59 devel Exp $

$Log: item_id.h,v $
Revision 1.7  2008/04/11 10:54:59  devel
added arkhata items

Revision 1.6  2007/06/07 15:15:54  devel
added caligar stuff

Revision 1.5  2006/10/04 17:30:57  devel
added some misisng ids

Revision 1.4  2006/09/26 10:59:25  devel
added questlog to nomad plains and brannington forest

Revision 1.3  2005/11/22 12:16:46  ssim
added stackable (demon) chips

Revision 1.2  2005/11/21 12:07:42  ssim
added logic for player-used demon sprite

Revision 1.1  2005/09/24 09:55:48  ssim
Initial revision

Revision 1.3  2003/10/16 13:02:27  sam
added some items from bran town (warr)

Revision 1.2  2003/10/13 14:12:16  sam
Added RCS tags


*/

#ifndef DEV_ID_DB
#define DEV_ID_DB		0x01		// ID of Daniel Brockhaus
#endif
#ifndef DEV_ID_MR
#define DEV_ID_MR		0x02		// ID of Markus Roeder
#endif

#ifndef DEV_ID_MAZE1
#define DEV_ID_MAZE1		0x03		// ID for generated keys in clan catacombs
#endif
#ifndef DEV_ID_MAZE2
#define DEV_ID_MAZE2		0x04		// ID for generated keys in random dungeon
#endif

#ifndef DEV_ID_LQ
#define DEV_ID_LQ		0x05		// ID for lq items

#define DEV_ID_WARR		0x06
#define DEV_ID_RHORUN		0x07
#define DEV_ID_WHITESTAR	0x08

#define DEV_ID_MISSION		0x09		// keys from mission area
#define DEV_ID_VELVET		0x0A		// keys from mission area

#define DEV_ID_FIRENA		0x13		// firena and tolight

#endif


// use this macro to build the drdata IDs
#define MAKE_ITEMID(dev_id,nr)	(((dev_id)<<24)|(nr))

#define IID_AREA1_BIGBEAR_TOOTH		MAKE_ITEMID(DEV_ID_DB,0x000001)	
#define IID_AREA1_SKELKEY1		MAKE_ITEMID(DEV_ID_DB,0x000002)	
#define IID_AREA1_SKELKEY2		MAKE_ITEMID(DEV_ID_DB,0x000003)	
#define IID_AREA1_SKELKEY3		MAKE_ITEMID(DEV_ID_DB,0x000004)	
#define IID_AREA1_SKELSKULL		MAKE_ITEMID(DEV_ID_DB,0x000005)	
#define IID_AREA1_WOODKEY		MAKE_ITEMID(DEV_ID_DB,0x000006)	
#define IID_AREA1_WOODSKULL		MAKE_ITEMID(DEV_ID_DB,0x000007)	
#define IID_AREA1_MAGESKULL		MAKE_ITEMID(DEV_ID_DB,0x000008)
#define IID_AREA1_WARLOCKSKULL		MAKE_ITEMID(DEV_ID_DB,0x000009)
#define IID_AREA1_WARLOCKKEY		MAKE_ITEMID(DEV_ID_DB,0x00000A)
#define IID_AREA1_VILLAGEAPPLE		MAKE_ITEMID(DEV_ID_DB,0x00000B)
#define IID_AREA1_WOODKEY2		MAKE_ITEMID(DEV_ID_DB,0x00000C)
#define IID_AREA1_WOODPOTION		MAKE_ITEMID(DEV_ID_DB,0x00000D)
#define IID_AREA1_ROBBERKEY1		MAKE_ITEMID(DEV_ID_DB,0x00000E)
#define IID_AREA1_CITYKEY1		MAKE_ITEMID(DEV_ID_DB,0x00000F)
#define IID_AREA1_CITYKEY2		MAKE_ITEMID(DEV_ID_DB,0x000010)
#define IID_AREA1_CITYKEY3		MAKE_ITEMID(DEV_ID_DB,0x000011)
#define IID_AREA1_CITYKEY4		MAKE_ITEMID(DEV_ID_DB,0x000012)
#define IID_AREA1_CITYKEY5		MAKE_ITEMID(DEV_ID_DB,0x000013)
#define IID_AREA1_CITYKEY6		MAKE_ITEMID(DEV_ID_DB,0x000014)
#define IID_AREA1_CITYKEY7		MAKE_ITEMID(DEV_ID_DB,0x000015)
#define IID_AREA1_GUILDKEY1		MAKE_ITEMID(DEV_ID_DB,0x000016)
#define IID_AREA1_MADKEY1		MAKE_ITEMID(DEV_ID_DB,0x000017)
#define IID_AREA1_MADKEY2		MAKE_ITEMID(DEV_ID_DB,0x000018)
#define IID_AREA1_MADKEY3		MAKE_ITEMID(DEV_ID_DB,0x000019)
#define IID_AREA1_MADKEY4		MAKE_ITEMID(DEV_ID_DB,0x00001A)
#define IID_AREA1_MADKEY5		MAKE_ITEMID(DEV_ID_DB,0x00001B)
#define IID_AREA1_MADPOTION		MAKE_ITEMID(DEV_ID_DB,0x00001C)
#define IID_AREA1_MADNOTE		MAKE_ITEMID(DEV_ID_DB,0x00001D)
#define IID_AREA1_CITYKEY8		MAKE_ITEMID(DEV_ID_DB,0x00001E)
#define IID_AREA1_MADKEY6		MAKE_ITEMID(DEV_ID_DB,0x00001F)
#define IID_AREA1_MADKEY7		MAKE_ITEMID(DEV_ID_DB,0x000020)
#define IID_AREA1_MADKEY8		MAKE_ITEMID(DEV_ID_DB,0x000021)
#define IID_AREA1_MADNOTE2		MAKE_ITEMID(DEV_ID_DB,0x000022)
#define IID_AREA1_MADKEY9		MAKE_ITEMID(DEV_ID_DB,0x000023)
#define IID_AREA1_CITYKEY9		MAKE_ITEMID(DEV_ID_DB,0x000024)
#define IID_AREA2_ZOMBIESKULL1		MAKE_ITEMID(DEV_ID_DB,0x000025)
#define IID_AREA2_ZOMBIESKULL2		MAKE_ITEMID(DEV_ID_DB,0x000026)
#define IID_AREA2_ZOMBIESKULL3		MAKE_ITEMID(DEV_ID_DB,0x000027)
#define IID_AREA2_LOISANNOTE		MAKE_ITEMID(DEV_ID_DB,0x000028)
#define IID_AREA3_ASTONKEY1		MAKE_ITEMID(DEV_ID_DB,0x000029)
#define IID_AREA3_ASTONKEY2		MAKE_ITEMID(DEV_ID_DB,0x00002A)
#define IID_AREA3_ASTONKEY3		MAKE_ITEMID(DEV_ID_DB,0x00002B)
#define IID_GENERIC_SPECIAL		MAKE_ITEMID(DEV_ID_DB,0x00002C)
#define IID_AREA2_ZOMBIEKEY		MAKE_ITEMID(DEV_ID_DB,0x00002D)
#define IID_AREA3_ASTONKEY4		MAKE_ITEMID(DEV_ID_DB,0x00002E)
#define IID_TRANSPORT			MAKE_ITEMID(DEV_ID_DB,0x00002F)
#define IID_AREA2_ZOMBIEKEY2		MAKE_ITEMID(DEV_ID_DB,0x000030)
#define IID_AREA2_ZOMBIEKEY3		MAKE_ITEMID(DEV_ID_DB,0x000031)
#define IID_AREA2_ZOMBIEKEY4		MAKE_ITEMID(DEV_ID_DB,0x000032)
#define IID_AREA2_ZOMBIEKEY5		MAKE_ITEMID(DEV_ID_DB,0x000033)
#define IID_CLANJEWEL			MAKE_ITEMID(DEV_ID_DB,0x000034)
#define IID_CLANTRANSPORT		MAKE_ITEMID(DEV_ID_DB,0x000035)
#define IID_AREA2_CREEPERHEAD		MAKE_ITEMID(DEV_ID_DB,0x000036)
#define IID_AREA2_SMALLSPIDER		MAKE_ITEMID(DEV_ID_DB,0x000037)
#define IID_AREA2_ASTRONOTE		MAKE_ITEMID(DEV_ID_DB,0x000038)
#define IID_AREA2_MOONYKEY1		MAKE_ITEMID(DEV_ID_DB,0x000039)
#define IID_AREA2_SUN1			MAKE_ITEMID(DEV_ID_DB,0x00003A)
#define IID_AREA2_SUN2			MAKE_ITEMID(DEV_ID_DB,0x00003B)
#define IID_AREA2_SUN3			MAKE_ITEMID(DEV_ID_DB,0x00003C)
#define IID_AREA2_SUN12			MAKE_ITEMID(DEV_ID_DB,0x00003D)
#define IID_AREA2_SUN13			MAKE_ITEMID(DEV_ID_DB,0x00003E)
#define IID_AREA2_SUN23			MAKE_ITEMID(DEV_ID_DB,0x00003F)
#define IID_AREA2_SUN123		MAKE_ITEMID(DEV_ID_DB,0x000040)
#define IID_AREA2_DAGGERWRONG		MAKE_ITEMID(DEV_ID_DB,0x000041)
#define IID_AREA2_DAGGERRIGHT		MAKE_ITEMID(DEV_ID_DB,0x000042)
#define IID_ALCHEMY_INGREDIENT		MAKE_ITEMID(DEV_ID_DB,0x000043)
#define IID_AREA6_KEY1			MAKE_ITEMID(DEV_ID_DB,0x000044)
#define IID_AREA6_KEY2			MAKE_ITEMID(DEV_ID_DB,0x000045)
#define IID_AREA6_KEY3			MAKE_ITEMID(DEV_ID_DB,0x000046)
#define IID_AREA6_KEY4			MAKE_ITEMID(DEV_ID_DB,0x000047)
#define IID_AREA6_GREENCRYSTAL		MAKE_ITEMID(DEV_ID_DB,0x000048)
#define IID_AREA6_YELLOWCRYSTAL		MAKE_ITEMID(DEV_ID_DB,0x000049)
#define IID_AREA8_REDCRYSTAL		MAKE_ITEMID(DEV_ID_DB,0x00004A)
#define IID_AREA8_BLOOD			MAKE_ITEMID(DEV_ID_DB,0x00004B)
#define IID_AREA1_JESTERCAP		MAKE_ITEMID(DEV_ID_DB,0x00004C)
#define IID_AREA10_MELTINGKEY1		MAKE_ITEMID(DEV_ID_DB,0x00004D)
#define IID_REFLECT_FIREBALL		MAKE_ITEMID(DEV_ID_DB,0x00004E)
#define IID_AREA10_CHESTKEY		MAKE_ITEMID(DEV_ID_DB,0x00004F)
#define IID_AREA11_PALACEKEY		MAKE_ITEMID(DEV_ID_DB,0x000050)
#define IID_AREA11_PALACEKEYPART	MAKE_ITEMID(DEV_ID_DB,0x000051)
#define IID_AREA12_TREASUREKEY1		MAKE_ITEMID(DEV_ID_DB,0x000052)
#define IID_AREA12_TREASUREKEY2		MAKE_ITEMID(DEV_ID_DB,0x000053)
#define IID_AREA12_TREASUREKEY3		MAKE_ITEMID(DEV_ID_DB,0x000054)
#define IID_AREA12_TREASUREKEY4		MAKE_ITEMID(DEV_ID_DB,0x000055)
#define IID_AREA12_TREASUREKEY5		MAKE_ITEMID(DEV_ID_DB,0x000056)
#define IID_AREA12_TREASUREKEY6		MAKE_ITEMID(DEV_ID_DB,0x000057)
#define IID_AREA12_TREASUREKEY7		MAKE_ITEMID(DEV_ID_DB,0x000058)
#define IID_AREA12_TREASUREKEY8		MAKE_ITEMID(DEV_ID_DB,0x000059)
#define IID_AREA14_STEELBAR		MAKE_ITEMID(DEV_ID_DB,0x00005A)
#define IID_AREA14_SHRINEKEY		MAKE_ITEMID(DEV_ID_DB,0x00005B)
#define IID_AREA15_HEAD			MAKE_ITEMID(DEV_ID_DB,0x00005C)
#define IID_HARDKILL			MAKE_ITEMID(DEV_ID_DB,0x00005D)
#define IID_ISLENARING			MAKE_ITEMID(DEV_ID_DB,0x00005E)
#define IID_AREA16_MANTIS		MAKE_ITEMID(DEV_ID_DB,0x00005F)
#define IID_AREA16_ROBBERKEY		MAKE_ITEMID(DEV_ID_DB,0x000060)
#define IID_AREA16_SKELLYKEY		MAKE_ITEMID(DEV_ID_DB,0x000061)
#define IID_AREA17_LOCKPICK		MAKE_ITEMID(DEV_ID_DB,0x000062)
#define IID_AREA17_PALACEKEY1		MAKE_ITEMID(DEV_ID_DB,0x000063)
#define IID_AREA17_PALACEKEY2		MAKE_ITEMID(DEV_ID_DB,0x000064)
#define IID_AREA17_PALACEKEY3		MAKE_ITEMID(DEV_ID_DB,0x000065)
#define IID_AREA17_PALACENOTE1		MAKE_ITEMID(DEV_ID_DB,0x000066)
#define IID_AREA17_PALACENOTE2		MAKE_ITEMID(DEV_ID_DB,0x000067)
#define IID_AREA17_PALACENOTE3		MAKE_ITEMID(DEV_ID_DB,0x000068)
#define IID_AREA17_MERCHANTNOTE1	MAKE_ITEMID(DEV_ID_DB,0x000069)
#define IID_AREA17_MERCHANTNOTE2	MAKE_ITEMID(DEV_ID_DB,0x00006A)
#define IID_AREA17_MERCHANTNOTE3	MAKE_ITEMID(DEV_ID_DB,0x00006B)
#define IID_AREA17_SEWERKEY1		MAKE_ITEMID(DEV_ID_DB,0x00006C)
#define IID_AREA17_SEWERKEY2		MAKE_ITEMID(DEV_ID_DB,0x00006D)
#define IID_AREA17_GOLDENLOCKPICK	MAKE_ITEMID(DEV_ID_DB,0x00006E)
#define IID_AREA17_LIBRARYKEY		MAKE_ITEMID(DEV_ID_DB,0x00006F)
#define IID_AREA14_RD100KEY		MAKE_ITEMID(DEV_ID_DB,0x000070)
#define IID_AREA17_BLOODBOWL		MAKE_ITEMID(DEV_ID_DB,0x000071)
#define IID_AREA17_GREENKEY		MAKE_ITEMID(DEV_ID_DB,0x000072)
#define IID_AREA17_REDKEY		MAKE_ITEMID(DEV_ID_DB,0x000073)
#define IID_AREA17_CROSS		MAKE_ITEMID(DEV_ID_DB,0x000074)
#define IID_AREA17_POISON		MAKE_ITEMID(DEV_ID_DB,0x000075)
#define IID_AREA17_ZOMBIEKEY		MAKE_ITEMID(DEV_ID_DB,0x000076)
#define IID_AREA18_BONE			MAKE_ITEMID(DEV_ID_DB,0x000077)
#define IID_AREA18_RUNE1		MAKE_ITEMID(DEV_ID_DB,0x000078)
#define IID_AREA18_RUNE2		MAKE_ITEMID(DEV_ID_DB,0x000079)
#define IID_AREA18_RUNE3		MAKE_ITEMID(DEV_ID_DB,0x00007A)
#define IID_AREA18_RUNE4		MAKE_ITEMID(DEV_ID_DB,0x00007B)
#define IID_AREA18_RUNE5		MAKE_ITEMID(DEV_ID_DB,0x00007C)
#define IID_AREA18_RUNE6		MAKE_ITEMID(DEV_ID_DB,0x00007D)
#define IID_AREA18_RUNE7		MAKE_ITEMID(DEV_ID_DB,0x00007E)
#define IID_AREA18_RUNE8		MAKE_ITEMID(DEV_ID_DB,0x00007F)
#define IID_AREA18_RUNE9		MAKE_ITEMID(DEV_ID_DB,0x000080)
#define IID_AREA17_TOWERKEY1		MAKE_ITEMID(DEV_ID_DB,0x000081)
#define IID_AREA17_TOWERKEY2		MAKE_ITEMID(DEV_ID_DB,0x000082)
#define IID_AREA17_TOWERKEY3		MAKE_ITEMID(DEV_ID_DB,0x000083)
#define IID_AREA17_TOWERKEY4		MAKE_ITEMID(DEV_ID_DB,0x000084)
#define IID_AREA17_TOWERKEY5		MAKE_ITEMID(DEV_ID_DB,0x000085)
#define IID_AREA17_TOWERKEY6		MAKE_ITEMID(DEV_ID_DB,0x000086)
#define IID_AREA17_TOWERKEY7		MAKE_ITEMID(DEV_ID_DB,0x000087)
#define IID_AREA17_TOWERKEY8		MAKE_ITEMID(DEV_ID_DB,0x000088)
#define IID_AREA17_TOWERKEY9		MAKE_ITEMID(DEV_ID_DB,0x000089)
#define IID_AREA19_WOLFSSKIN		MAKE_ITEMID(DEV_ID_DB,0x00008A)
#define IID_AREA19_SALT			MAKE_ITEMID(DEV_ID_DB,0x00008B)
#define IID_AREA19_WOLFSSKIN2		MAKE_ITEMID(DEV_ID_DB,0x00008C)
#define IID_AREA19_KIR			MAKE_ITEMID(DEV_ID_DB,0x00008D)
#define IID_AREA19_KIRKEY		MAKE_ITEMID(DEV_ID_DB,0x00008E)
#define IID_AREA19_KIRLETTER		MAKE_ITEMID(DEV_ID_DB,0x00008F)
#define IID_AREA25_TELEKEY		MAKE_ITEMID(DEV_ID_DB,0x000090)
#define IID_AREA25_DOORKEY		MAKE_ITEMID(DEV_ID_DB,0x000091)
#define IID_SHRIKE_TALISMAN		MAKE_ITEMID(DEV_ID_DB,0x000092)
#define IID_CARLOS_DOOR			MAKE_ITEMID(DEV_ID_DB,0x000093)
#define IID_DWARFRECALL1		MAKE_ITEMID(DEV_ID_DB,0x000094)
#define IID_DWARFRECALL2		MAKE_ITEMID(DEV_ID_DB,0x000095)
#define IID_DWARFRECALL3		MAKE_ITEMID(DEV_ID_DB,0x000096)
#define IID_DWARFRECALL4		MAKE_ITEMID(DEV_ID_DB,0x000097)
#define IID_MINEGATEWAY			MAKE_ITEMID(DEV_ID_DB,0x000098)
#define IID_LIZARDTOOTH			MAKE_ITEMID(DEV_ID_DB,0x000099)
#define IID_BROWNBERRY			MAKE_ITEMID(DEV_ID_DB,0x00009A)
#define IID_LIZARDHEAD			MAKE_ITEMID(DEV_ID_DB,0x00009B)
#define IID_LIZARDMOLD			MAKE_ITEMID(DEV_ID_DB,0x00009C)
#define IID_MISSIONFIGHTER		MAKE_ITEMID(DEV_ID_DB,0x00009D)
#define IID_MISSIONCHEST		MAKE_ITEMID(DEV_ID_DB,0x00009E)
#define IID_MISSIONDOOR1		MAKE_ITEMID(DEV_ID_DB,0x00009F)
#define IID_MISSIONDOOR2		MAKE_ITEMID(DEV_ID_DB,0x0000A0)
#define IID_MISSIONENTRY		MAKE_ITEMID(DEV_ID_DB,0x0000A1)
#define IID_TUNNELDOOR1			MAKE_ITEMID(DEV_ID_DB,0x0000A2)
#define IID_TUNNELDOOR2			MAKE_ITEMID(DEV_ID_DB,0x0000A3)
#define IID_TUNNELENEMY1		MAKE_ITEMID(DEV_ID_DB,0x0000A4)
#define IID_TUNNELENEMY2		MAKE_ITEMID(DEV_ID_DB,0x0000A5)
#define IID_TUNNELENEMY3		MAKE_ITEMID(DEV_ID_DB,0x0000A6)
#define IID_TUNNELENEMYALL		MAKE_ITEMID(DEV_ID_DB,0x0000A7)
#define IID_DEMONSKIN1			MAKE_ITEMID(DEV_ID_DB,0x0000A8)
#define IID_DEMONSKIN2			MAKE_ITEMID(DEV_ID_DB,0x0000A9)
#define IID_DEMONSKIN3			MAKE_ITEMID(DEV_ID_DB,0x0000AA)
#define IID_DEMONSKIN4			MAKE_ITEMID(DEV_ID_DB,0x0000AB)
#define IID_BRONZECHIP			MAKE_ITEMID(DEV_ID_DB,0x0000AC)
#define IID_SILVERCHIP			MAKE_ITEMID(DEV_ID_DB,0x0000AD)
#define IID_GOLDCHIP			MAKE_ITEMID(DEV_ID_DB,0x0000AE)
#define IID_CALIGARLETTER               MAKE_ITEMID(DEV_ID_DB,0x0000AF)
#define IID_CALIGARKEYP1                MAKE_ITEMID(DEV_ID_DB,0x0000B0)
#define IID_CALIGARKEYP2                MAKE_ITEMID(DEV_ID_DB,0x0000B1)
#define IID_CALIGARKEYP3                MAKE_ITEMID(DEV_ID_DB,0x0000B2)
#define IID_CALIGARHOMDENRING           MAKE_ITEMID(DEV_ID_DB,0x0000B3)
#define IID_CALIGARKEYP1                MAKE_ITEMID(DEV_ID_DB,0x0000B0)
#define IID_CALIGARKEYP2                MAKE_ITEMID(DEV_ID_DB,0x0000B1)
#define IID_CALIGARKEYP3                MAKE_ITEMID(DEV_ID_DB,0x0000B2)
#define IID_CALIGARPALACEKEYPART        MAKE_ITEMID(DEV_ID_DB,0x0000B3)
#define IID_CALIGARPLAQUE               MAKE_ITEMID(DEV_ID_DB,0x0000B4)

#define IID_ARKHATA_CROWN		MAKE_ITEMID(DEV_ID_DB,0x0000B5)
#define IID_ARKHATA_BRACELET		MAKE_ITEMID(DEV_ID_DB,0x0000B6)
#define IID_ARKHATA_RING		MAKE_ITEMID(DEV_ID_DB,0x0000B7)
#define IID_ARKHATA_MONKPART1		MAKE_ITEMID(DEV_ID_DB,0x0000B8)
#define IID_ARKHATA_MONKPART2		MAKE_ITEMID(DEV_ID_DB,0x0000B9)
#define IID_ARKHATA_MONKPART3		MAKE_ITEMID(DEV_ID_DB,0x0000BA)
#define IID_ARKHATA_LETTER1		MAKE_ITEMID(DEV_ID_DB,0x0000BB)
#define IID_ARKHATA_LETTER2		MAKE_ITEMID(DEV_ID_DB,0x0000BC)
#define IID_ARKHATA_LETTER3		MAKE_ITEMID(DEV_ID_DB,0x0000BD)
#define IID_ARKHATA_LETTER4		MAKE_ITEMID(DEV_ID_DB,0x0000BE)
#define IID_ARKHATA_LETTER5		MAKE_ITEMID(DEV_ID_DB,0x0000BF)
#define IID_ARKHATA_BLADE		MAKE_ITEMID(DEV_ID_DB,0x0000C0)
#define IID_ARKHATA_IRONPOT		MAKE_ITEMID(DEV_ID_DB,0x0000C1)
#define IID_ARKHATA_SCROLL1		MAKE_ITEMID(DEV_ID_DB,0x0000C2)
#define IID_ARKHATA_SCROLL2		MAKE_ITEMID(DEV_ID_DB,0x0000C3)
#define IID_ARKHATA_BUDDA		MAKE_ITEMID(DEV_ID_DB,0x0000C4)
#define IID_ARKHATA_IRONPOTION		MAKE_ITEMID(DEV_ID_DB,0x0000C5)
#define IID_ARKHATA_NOTE1		MAKE_ITEMID(DEV_ID_DB,0x0000C6)
#define IID_ARKHATA_NOTE2		MAKE_ITEMID(DEV_ID_DB,0x0000C7)
#define IID_ARKHATA_NOTE3		MAKE_ITEMID(DEV_ID_DB,0x0000C8)
#define IID_ARKHATA_HARPY		MAKE_ITEMID(DEV_ID_DB,0x0000C9)
#define IID_ARKHATA_DICTIONARY		MAKE_ITEMID(DEV_ID_DB,0x0000CA)

#define IID_ARKHATA_AKEY1		MAKE_ITEMID(DEV_ID_DB,0x0000CA)
#define IID_ARKHATA_AKEY2		MAKE_ITEMID(DEV_ID_DB,0x0000CB)
#define IID_ARKHATA_AKEY3		MAKE_ITEMID(DEV_ID_DB,0x0000CC)
#define IID_ARKHATA_AKEY12		MAKE_ITEMID(DEV_ID_DB,0x0000CD)
#define IID_ARKHATA_AKEY23		MAKE_ITEMID(DEV_ID_DB,0x0000CE)

#define IID_ARKHATA_FORTRESSKEY		MAKE_ITEMID(DEV_ID_FIRENA,0x000014)
#define IID_ARKHATA_AKEY		MAKE_ITEMID(DEV_ID_FIRENA,0x000089)
								
#define IID_CALIGAROBELISK1             MAKE_ITEMID(DEV_ID_VELVET,0x000011)
#define IID_CALIGAROBELISK2             MAKE_ITEMID(DEV_ID_VELVET,0x000012)
#define IID_CALIGAROBELISK3             MAKE_ITEMID(DEV_ID_VELVET,0x000013)
#define IID_CALIGARDUNGEONKEY           MAKE_ITEMID(DEV_ID_VELVET,0x000014)
								
#define IID_LAB2_ELIASHAT               MAKE_ITEMID(DEV_ID_MR,0x000001)
#define IID_LAB2_ELIASCAPE              MAKE_ITEMID(DEV_ID_MR,0x000002)
#define IID_LAB2_ELIASBOOTS             MAKE_ITEMID(DEV_ID_MR,0x000003)
#define IID_LAB2_ELIASBELT              MAKE_ITEMID(DEV_ID_MR,0x000004)
#define IID_LAB2_ARATHASRING            MAKE_ITEMID(DEV_ID_MR,0x000005)
#define IID_LAB2_HERALDSKEY             MAKE_ITEMID(DEV_ID_MR,0x000006)
#define IID_LAB3_PRISONKEY              MAKE_ITEMID(DEV_ID_MR,0x000007)
#define IID_LAB4_MAGEKEY                MAKE_ITEMID(DEV_ID_MR,0x000008)
#define IID_NEVERFOUND                  MAKE_ITEMID(DEV_ID_MR,0x000009)
#define IID_thisoneisfreenow            MAKE_ITEMID(DEV_ID_MR,0x00000A)
#define IID_LAB4_SZEPTER                MAKE_ITEMID(DEV_ID_MR,0x00000B)
#define IID_LAB4_CROWN                  MAKE_ITEMID(DEV_ID_MR,0x00000C)
#define IID_LAB5_HEAD1                  MAKE_ITEMID(DEV_ID_MR,0x00000D)
#define IID_LAB5_HEAD2                  MAKE_ITEMID(DEV_ID_MR,0x00000E)
#define IID_LAB5_HEAD3                  MAKE_ITEMID(DEV_ID_MR,0x00000F)
#define IID_LAB5_WEAPON                 MAKE_ITEMID(DEV_ID_MR,0x000010)
#define IID_LAB5_KEY1                   MAKE_ITEMID(DEV_ID_MR,0x000011)

#define IID_STAFF_SMUGGLEKEY1           MAKE_ITEMID(DEV_ID_WARR,0x000001)
#define IID_STAFF_SMUGGLEKEY2           MAKE_ITEMID(DEV_ID_WARR,0x000002)
#define IID_STAFF_SMUGGLEKEY3           MAKE_ITEMID(DEV_ID_WARR,0x000003)
#define IID_STAFF_SMUGGLEKEY4           MAKE_ITEMID(DEV_ID_WARR,0x000004)
#define IID_STAFF_SMUGGLEBOOK           MAKE_ITEMID(DEV_ID_WARR,0x000005)
#define IID_STAFF_SMUGGLEPEARLS         MAKE_ITEMID(DEV_ID_WARR,0x000006)
#define IID_STAFF_SMUGGLERING           MAKE_ITEMID(DEV_ID_WARR,0x000007)
#define IID_STAFF_SMUGGLECAPE           MAKE_ITEMID(DEV_ID_WARR,0x000008)
#define IID_STAFF_SMUGGLENECKLACE       MAKE_ITEMID(DEV_ID_WARR,0x000009)

#define IID_STAFF_BLUEKEY1	       	MAKE_ITEMID(DEV_ID_WARR,0x00000A)
#define IID_STAFF_BLUEKEY2	       	MAKE_ITEMID(DEV_ID_WARR,0x00000B)
#define IID_STAFF_BLUEKEY3	       	MAKE_ITEMID(DEV_ID_WARR,0x00000C)
#define IID_STAFF_BLUEKEY12	       	MAKE_ITEMID(DEV_ID_WARR,0x00000D)
#define IID_STAFF_BLUEKEY13	       	MAKE_ITEMID(DEV_ID_WARR,0x00000E)
#define IID_STAFF_BLUEKEY23	       	MAKE_ITEMID(DEV_ID_WARR,0x00000F)
#define IID_STAFF_BLUEKEY123	       	MAKE_ITEMID(DEV_ID_WARR,0x000010)
#define IID_STAFF_GREENKEY1	       	MAKE_ITEMID(DEV_ID_WARR,0x000011)
#define IID_STAFF_GREENKEY2	       	MAKE_ITEMID(DEV_ID_WARR,0x000012)
#define IID_STAFF_GREENKEY3	       	MAKE_ITEMID(DEV_ID_WARR,0x000013)
#define IID_STAFF_GREENKEY12	       	MAKE_ITEMID(DEV_ID_WARR,0x000014)
#define IID_STAFF_GREENKEY13	       	MAKE_ITEMID(DEV_ID_WARR,0x000015)
#define IID_STAFF_GREENKEY23	       	MAKE_ITEMID(DEV_ID_WARR,0x000016)
#define IID_STAFF_GREENKEY123	       	MAKE_ITEMID(DEV_ID_WARR,0x000017)
#define IID_STAFF_REDKEY1	       	MAKE_ITEMID(DEV_ID_WARR,0x000018)
#define IID_STAFF_REDKEY2	       	MAKE_ITEMID(DEV_ID_WARR,0x000019)
#define IID_STAFF_REDKEY3	       	MAKE_ITEMID(DEV_ID_WARR,0x00001A)
#define IID_STAFF_REDKEY12	       	MAKE_ITEMID(DEV_ID_WARR,0x00001B)
#define IID_STAFF_REDKEY13	       	MAKE_ITEMID(DEV_ID_WARR,0x00001C)
#define IID_STAFF_REDKEY23	       	MAKE_ITEMID(DEV_ID_WARR,0x00001D)
#define IID_STAFF_REDKEY123	       	MAKE_ITEMID(DEV_ID_WARR,0x00001E)
#define IID_STAFF_COUNTJEWEL	       	MAKE_ITEMID(DEV_ID_WARR,0x00001F)
#define IID_STAFF_COUNTESSAJEWEL       	MAKE_ITEMID(DEV_ID_WARR,0x000020)
#define IID_STAFF_DAUGHTERJEWEL	       	MAKE_ITEMID(DEV_ID_WARR,0x000021)
#define IID_STAFF_MAUSOLEUMKEY1	       	MAKE_ITEMID(DEV_ID_WARR,0x000022)
#define IID_STAFF_MAUSOLEUMKEY2	       	MAKE_ITEMID(DEV_ID_WARR,0x000023)
#define IID_STAFF_MAUSOLEUMKEY3	       	MAKE_ITEMID(DEV_ID_WARR,0x000024)
#define IID_STAFF_HOLYRELIC	       	MAKE_ITEMID(DEV_ID_WARR,0x000025)
#define IID_STAFF_BRENNETHDAGGER       	MAKE_ITEMID(DEV_ID_WARR,0x000026)
#define IID_STAFF_BRENNETHPOTION       	MAKE_ITEMID(DEV_ID_WARR,0x000027)
#define IID_STAFF_BRENNETHJOURNAL      	MAKE_ITEMID(DEV_ID_WARR,0x000028)
#define IID_STAFF_FORESTMAP	       	MAKE_ITEMID(DEV_ID_WARR,0x000029)
#define IID_STAFF_THIEFKEY1	       	MAKE_ITEMID(DEV_ID_WARR,0x00002A)
#define IID_STAFF_THIEFKEY2	       	MAKE_ITEMID(DEV_ID_WARR,0x00002B)
#define IID_STAFF_THIEFKEY3	       	MAKE_ITEMID(DEV_ID_WARR,0x00002C)
#define IID_STAFF_NECROKEY	       	MAKE_ITEMID(DEV_ID_WARR,0x00002D)

#define IID_STAFF_DRAGONKEY1       	MAKE_ITEMID(DEV_ID_RHORUN,0x000001)
#define IID_STAFF_DRAGONKEY2       	MAKE_ITEMID(DEV_ID_RHORUN,0x000002)
#define IID_STAFF_DRAGONKEY3       	MAKE_ITEMID(DEV_ID_RHORUN,0x000003)
#define IID_STAFF_DRAGONKEY4       	MAKE_ITEMID(DEV_ID_RHORUN,0x000004)

#define IID_STAFF_DRAGONSTAFF       	MAKE_ITEMID(DEV_ID_RHORUN,0x000010)

#define IID_STAFF_ROBBERKEYAREA1       	MAKE_ITEMID(DEV_ID_WHITESTAR,0x000001)
#define IID_STAFF_SEWERKEY       	MAKE_ITEMID(DEV_ID_WHITESTAR,0x000002)
#define IID_STAFF_ROBBERKEY1       	MAKE_ITEMID(DEV_ID_WHITESTAR,0x000003)
#define IID_STAFF_ROBBERKEY2       	MAKE_ITEMID(DEV_ID_WHITESTAR,0x000004)
#define IID_STAFF_ROBBERKEY3       	MAKE_ITEMID(DEV_ID_WHITESTAR,0x000005)
#define IID_STAFF_ROBBERKEY4       	MAKE_ITEMID(DEV_ID_WHITESTAR,0x000006)
#define IID_STAFF_ROBBERKEY5       	MAKE_ITEMID(DEV_ID_WHITESTAR,0x000007)
#define IID_STAFF_ROBBERKEY6       	MAKE_ITEMID(DEV_ID_WHITESTAR,0x000008)
#define IID_STAFF_ROBBERKEY7       	MAKE_ITEMID(DEV_ID_WHITESTAR,0x000009)
#define IID_STAFF_ROBBERKEY8       	MAKE_ITEMID(DEV_ID_WHITESTAR,0x00000A)
#define IID_STAFF_BOSSLAIR       	MAKE_ITEMID(DEV_ID_WHITESTAR,0x00000B)
#define IID_STAFF_BOSSMASTER       	MAKE_ITEMID(DEV_ID_WHITESTAR,0x00000C)
#define IID_STAFF_PICKAXE       	MAKE_ITEMID(DEV_ID_WHITESTAR,0x00000D)
#define IID_STAFF_ARIKEY       		MAKE_ITEMID(DEV_ID_WHITESTAR,0x00000E)
#define IID_STAFF_ARIAMULET       	MAKE_ITEMID(DEV_ID_WHITESTAR,0x00000F)
#define IID_STAFF_BEARHEAD       	MAKE_ITEMID(DEV_ID_WHITESTAR,0x000010)

/* DRDATA usage:

[39]	doors timer counter			
[38]	doors reset dlight
[37]	hardkill level
[36]	hardkill flags


*/








